;;;;;;;;;;;;;;;;;;;;;Liste des routines
;new_interupt
;compt_interupt		=> 1 seconde = 350 Hz
;clr_scr
;clr_scr_tmp
;move_tmp_to_scr
;invert_part
;calcul_pixel
;util_process
;put_circle

new_interupt rte

compt_interupt	add.l #1,timer
	rte

clr_scr
	movem.l d0/a0,-(a7)
	lea $4c00,a0
	move.l #749,d0
\clr_scr_loop	clr.l (a0)+
	dbra d0,\clr_scr_loop
	movem.l (a7)+,d0/a0
        rts

clr_scr_tmp
	movem.l d0/a0,-(a7)
	move.l adresse_screen,a0
	move.l #749,d0
\clr_scr_loop	clr.l (a0)+
	dbra d0,\clr_scr_loop
	movem.l (a7)+,d0/a0
        rts

move_tmp_to_scr
	movem.l d0/a0-a1,-(a7)
	move.l adresse_screen,a0
	lea $4c00,a1
	move.l #749,d0
\move_tmp_to_scr_loop	move.l (a0)+,(a1)+
	dbra d0,\move_tmp_to_scr_loop
	movem.l (a7)+,d0/a0-a1
	rts

invert_part
	movem.l d0/a0,-(a7)
	move.l adresse_screen,a0
	move.l #49,d0
\create_background_loop1
	not.l (a0)+
	not.l (a0)+
	not.w (a0)+
	add.l #20,a0
	dbra d0,\create_background_loop1
	add.l #10,a0
	move.l #49,d0
\create_background_loop2
	not.l (a0)+
	not.l (a0)+
	not.w (a0)+
	add.l #20,a0
	dbra d0,\create_background_loop2
	movem.l (a7)+,d0/a0
	rts

calcul_pixel
	clr.l d0
	move.w temps,d0
	add.w #8,d0
	divu #50,d0			;module d0...
	clr.w d0			;
	swap d0				;... par 50
	lea cos,a0
	mulu #2,d0
	add.l d0,a0
	move.w (a0),d0			;d0 = le sinus de t + 8
	add.w #72,d0			;d0 = x
	clr.l d1
	move.w temps,d1
	divu #50,d1			;module d1...
	clr.w d1			;
	swap d1				;... par 50
	lea sin,a0
	mulu #2,d1
	add.l d1,a0
	move.w (a0),d1			;d1 = le sinus de t
	add.w #42,d1			;d1 = y
	rts

util_process
	movem.l d0-d1/a0,-(a7)
	move.l adresse_screen,a0
	add.l #19,a0
	move.l #99,d0
\util_process_loop	bclr.w #0,(a0)
	bclr.w #1,(a0)
	bclr.w #2,(a0)
	add.l #30,a0
	dbra d0,\util_process_loop	;efface les 3 last pixels visibles
	move.l timer,d0
	sub.l old_timer,d0
	mulu #100,d0
	clr.l d1
	move.l speed,d1
	divu d1,d0
	swap d0
	clr.w d0
	swap d0			;d0 contient le % utilise sur 1 WORD
	add.w #1,d0		;add 1 car cette routine prend du tps
	cmp.w #100,d0		;si d0 > 100 on met 100
	bls \util_process_suite ;Branch Lower or Same (non signe)
	move.w #100,d0
\util_process_suite
	move.l adresse_screen,a0
	add.l #99*30+19,a0		;a0 pointe le last byte du screen
	sub.w #1,d0
\util_process_loop2 bset.w #0,(a0)
	bset.w #1,(a0)
	sub.l #30,a0
	dbra d0,\util_process_loop2
	movem.l (a7)+,d0-d1/a0
	rts


put_circle
	movem.l d0-d7/a0-a6,-(a7)
	clr.l d3
	move.l #circle,a0

	move.w #15,d6	;hauteur en pixels
	move.w #1,d7	;largeur en octets


	bsr commun
	addq.b #1,d0	;pour viter un dcalage  droite
	clr.w d4
	move.b d3,d4
	lsl.w d0,d4
toutsprite:
	move.w d7,d5
	move.l a1,a3
lignesprite:
	move.w d4,d3
	bsr.s afficheoctet
	dbra d5,lignesprite
	lea 30(a1),a1
	dbra d6,toutsprite
	movem.l (a7)+,d0-d7/a0-a6
	RTS

commun:
	move.l adresse_screen,a1
	add.w d1,d1
	move.w d1,d4
	lsl.w #4,d1
	sub.w d4,d1		;x*30
	move.w d0,d4
	lsr.w #3,d4
	add.w d4,d1
	add.w d1,a1
	not.b d0
	andi.b #7,d0
	RTS

afficheoctet:
;	d0=dcalage
;	d2=bout du sprite
;	d3=masque
;	a3=adresse de l'cran
	clr.w d2
	move.b (a0)+,d2
	lsl.w d0,d2
	move.b (a3)+,d1	;pour viter une jolie "Address Error"
	lsl.w #8,d1
	move.b (a3),d1
	or.w d2,d1		;affiche les pixels
	not.w d3
	or.w d3,d2		;seuls les 0 qui doivent tre affichs restent des 0
	and.w d2,d1		;efface...
	move.b d1,(a3)
	lsr.w #8,d1
	move.b d1,-1(a3)
	RTS