	include "tios.h"
	xdef	_ti89
	xdef	_comment
	xdef	_main
	include "dm1_macr.asm"

_main	int_off
	jsr clr_scr
	move.l #178,d0
	lea $4c00,a0
invert_loop	not.l (a0)+
	dbra d0,invert_loop
	set_font #2
	write_str #25,#8,#0,_comment
	set_font #0
	write_str #15,#30,#1,during
	write_str #20,#37,#1,key1
	write_str #20,#44,#1,key2
	write_str #20,#51,#1,key3
	write_str #15,#65,#1,made1
	write_str #35,#72,#1,made2
	set_font #1
	write_str #42,#85,#1,pressenter
main_loop
	get_key mask6
	btst.b #0,stat_key
	beq exit
	get_key mask1
	btst.b #0,stat_key
	bne main_loop

	clr.w temps
loop	move.l timer,old_timer
	jsr clr_scr_tmp
	jsr calcul_pixel
	move.l d0,-(a7)
	move.l d1,-(a7)
	jsr put_circle
	move.l (a7)+,d1
	move.l (a7)+,d0
	sub.l #72,d0
	neg.l d0
	add.l #72,d0
	jsr put_circle

	add.w #25,temps
	jsr calcul_pixel
	move.l d0,-(a7)
	move.l d1,-(a7)
	jsr put_circle
	move.l (a7)+,d1
	move.l (a7)+,d0
	sub.l #72,d0
	neg.l d0
	add.l #72,d0
	jsr put_circle

	jsr invert_part
	sub.w #24,temps
	clr.l d0
	move.w temps,d0
	divu #50,d0			;module d0...
	swap d0				;... par 50
	move.w d0,temps
	jsr util_process
	jsr move_tmp_to_scr


	get_key	mask6
	btst.b #0,stat_key
	beq exit
	get_key mask1
	btst.b #1,stat_key
	bne no_plus
	jsr tios::OSContrastUp
	bra loop_temp
no_plus	btst.b #2,stat_key
	bne no_moins
	jsr tios::OSContrastDn
	bra loop_temp
no_moins	get_key mask0
	btst.b #0,stat_key
	bne no_up
	sub.l #1,speed
	cmp.l #1,speed
	bne loop_temp
	move.l #2,speed
	bra loop_temp
no_up	btst.b #2,stat_key
	bne loop2
	add.l #1,speed
	cmp.l #103,speed
	bne loop_temp
	move.l #102,speed
loop_temp	move.l timer,old_timer
	move.l #102,d0
	sub.l speed,d0
	print_d0 #55,#60,#1
	write_str #10,#60,#1,speedstr
loop_temp2	move.l timer,d0
	sub.l old_timer,d0
	cmp.l #40,d0
	bgt loop
	bra loop_temp2
loop2	move.l timer,d0
	sub.l old_timer,d0
	cmp.l speed,d0
	bgt loop
	bra loop2

exit	int_on
	rts

	include	"dm1_rout.asm"

circle	dc.b %00000011,%11000000
	dc.b %00001111,%11110000
	dc.b %00011111,%11111000
	dc.b %00111111,%11111100
	dc.b %01111111,%11111110
	dc.b %01111111,%11111110
	dc.b %11111111,%11111111
	dc.b %11111111,%11111111
	dc.b %11111111,%11111111
	dc.b %11111111,%11111111
	dc.b %01111111,%11111110
	dc.b %01111111,%11111110
	dc.b %00111111,%11111100
	dc.b %00011111,%11111000
	dc.b %00001111,%11110000
	dc.b %00000011,%11000000


;	angle:50	nb de points:50		points/line:15
;	pour cos : multiplier par 50
;	pour sin : multiplier par 40

cos:
 dc.w 50,49,48,46,43,40,36,31,26,21,15,9,3,-3,-9
 dc.w -15,-21,-26,-31,-36,-40,-43,-46,-48,-49,-50,-49,-48,-46,-43
 dc.w -40,-36,-31,-26,-21,-15,-9,-3,3,9,15,21,26,31,36
 dc.w 40,43,46,48,49

sin:
 dc.w 0,5,9,14,19,23,27,30,33,36,38,39,39,39,39
 dc.w 38,36,33,30,27,23,19,14,9,5,0,-5,-9,-14,-19
 dc.w -23,-27,-30,-33,-36,-38,-39,-39,-39,-39,-38,-36,-33,-30,-27
 dc.w -23,-19,-14,-9,-5

mask0 equ %11111110  ;(up\2nd\donw...)
mask1 equ %11111101  ;(Enter\clear...)
mask2 equ %11111011  ;( <- )
mask3 equ %11110111  ;(catalog...)
mask4 equ %11101111  ;(Mode...)
mask5 equ %11011111  ;(Home...)
mask6 equ %10111111  ;(ESC...)
old_int_1	dc.l 0
old_int_2	dc.l 0
old_int_3	dc.l 0
old_int_4	dc.l 0
old_int_5	dc.l 0
old_int_6	dc.l 0
old_int_7	dc.l 0
handle_screen	dc.w 0
adresse_screen	dc.l 0
temps	dc.w 0
timer	dc.l 0
old_timer dc.l 0
speed		dc.l 10

str	ds.b 9
stat_key	dc.b 0

speedstr dc.b "SPEED :",0
during dc.b "Keys during the simulation :",0
key1 dc.b "ESC ...",0
key2 dc.b "[+] and [-] to change the contrast",0
key3 dc.b "Up and Down to change the speed",0
made1 dc.b "Made by LubnanTI",0
made2 dc.b "yves_c07@yahoo.com",0
pressenter dc.b "Press ENTER",0
_comment   dc.b    "DEMO V1.1",0
        end